module data( out, sco, in, loadM, loadQ, loadD, shl, sel, selM, soutR, soutQ, NshlM, clk);

	output[3:0]	out;
	output						sco;
	input[3:0]		in;
	input						loadM, loadQ, loadD, shl, sel, selM, soutQ, soutR, NshlM, clk;
	reg[3:0]				M, Q;
	reg[4:0]				D;
	reg						spatil;

	reg[4:0]			result;
	reg[3:0]			out;

	assign sco = spatil;

	always @(D, M, sel)
	begin
		if( sel == 1'b0)
			result = {spatil, M} + D;
		else
			result = {spatil, M} + ~D + 1;
	end

	always @(posedge clk)
	begin
		if( loadM == 1'b1)
		begin
			if( selM == 1'b1)
				{spatil, M[3:0]} = {1'b0, in[3:0]};
			else
				{spatil, M[3:0]} = {result[4:0]};
		end
		else if( loadQ == 1'b1)
			Q = in;
		else if( loadD == 1'b1)
			D = in;
		else if( shl == 1'b1)
			if( NshlM == 1'b0)
				{spatil, M[3:0], Q[3:0]} = {M[3:0], Q[3:0], ~spatil};
			else
			begin
				if( spatil == 1'b1)
					M = {spatil, M} + D;

				{spatil, Q[3:0]} = {Q[3:0], ~spatil};	
			end
		else if( soutQ == 1'b1)
			out = Q;
		else if( soutR == 1'b1)
			out = M;
	end

	initial
	begin
		spatil = 1'b0;
		D[4] = 1'b0;
	end

endmodule